/*
 * Practice using gdb to inspect stack frames. Compile this program
 * using gcc -g and without optimization (so that you get a direct
 * translation of C statements into assembler code).
 *
 * Helpful gdb commands (note that commands can be abbreviated):
 *
 * run                     start debugged program (r)
 * break                   set a breakpoint (br)
 * delete                  delete breakpoints and other things (d)
 * print                   print something interesting (p)
 * continue                continue program being debugged (c)
 * step                    step debugged program (s)
 * x                       examine memory (e.g., x/10x $sp)
 * 
 * backtrace               show backtrace starting at main (bt)
 * backtrace -past-main    show complete backrace
 * up                      go up in the stack
 * down                    go down in the stack
 * frame                   print a stack frame
 * 
 * info frame              general info about current stack frame
 * info registers          general info about all registers
 */
 
int c()
{
    int x = 0x42424200;
    return x;
}

void b(int *p)
{
    int x = c();
    *p = ++x;
}

int a()
{
    int x;
    b(&x);
    return ++x;
}

int main(void)
{
    int x = a();
    return (++x) & 0xff;
}
